--- a/Makefile
+++ b/Makefile
@@ -40,16 +40,29 @@ KMIN := $(shell echo $(KVER) | \
 KREV := $(shell echo $(KVER) | \
 	sed -e 's/^[0-9][0-9]*\.[0-9][0-9]*\.\([0-9][0-9]*\).*/\1/')
 
-kver_eq = $(shell [ $(KMAJ)$(KMIN)$(KREV) -eq $(1)$(2)$(3) ] && \
+kver_eq = $(shell [ $(KMAJ) -eq $(1) -a $(KMIN) -eq $(2) -a $(KREV) -eq $(3) ] && \
 	echo 1 || echo 0)
-kver_lt = $(shell [ $(KMAJ)$(KMIN)$(KREV) -lt $(1)$(2)$(3) ] && \
+
+kver_lt = $(shell [ $(KMAJ) -lt $(1) -o \
+	 $(KMAJ) -eq $(1) -a $(KMIN) -lt $(2) -o \
+	 $(KMAJ) -eq $(1) -a $(KMIN) -eq $(2) -a $(KREV) -lt $(3) ] && \
 	echo 1 || echo 0)
-kver_le = $(shell [ $(KMAJ)$(KMIN)$(KREV) -le $(1)$(2)$(3) ] && \
+
+kver_le = $(shell [ $(KMAJ) -lt $(1) -o \
+	 $(KMAJ) -eq $(1) -a $(KMIN) -lt $(2) -o \
+	 $(KMAJ) -eq $(1) -a $(KMIN) -eq $(2) -a $(KREV) -le $(3) ] && \
 	echo 1 || echo 0)
-kver_gt = $(shell [ $(KMAJ)$(KMIN)$(KREV) -gt $(1)$(2)$(3) ] && \
+
+kver_gt = $(shell [ ( $(KMAJ) -gt $(1) ) -o \
+	 $(KMAJ) -eq $(1) -a $(KMIN) -gt $(2) -o \
+	 $(KMAJ) -eq $(1) -a $(KMIN) -eq $(2) -a $(KREV) -gt $(3) ] && \
 	echo 1 || echo 0)
-kver_ge = $(shell [ $(KMAJ)$(KMIN)$(KREV) -ge $(1)$(2)$(3) ] && \
+
+kver_ge = $(shell [ ( $(KMAJ) -gt $(1) ) -o \
+	 $(KMAJ) -eq $(1) -a $(KMIN) -gt $(2) -o \
+	 $(KMAJ) -eq $(1) -a $(KMIN) -eq $(2) -a $(KREV) -ge $(3) ] && \
 	echo 1 || echo 0)
+
 kver_lk = $(shell [ `echo $(KVER) | egrep $(1)` ] && echo 1 || echo 0)
 
 #
